﻿Type=Class
Version=3.8
B4A=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Public PARK_TYPE_NEW As String = "New"
	Public PARK_TYPE_RECENT As String = "Recent"
	Public PARK_TYPE_CURRENT As String = "Current"
	
	Public CURRENT_COLOUR As Int = Colors.ARGB(213,41,41,147)
	Public NEW_COLOUR As Int = Colors.ARGB(205,28,121,28)
	Public RECENT_COLOUR As Int = Colors.ARGB(205,254,139,44)
	Public RECENT_COLOUR2 As Int = Colors.ARGB(205,254,139,44)
	
	Public IsTimeBased As Boolean
	
	Private mTarget As Object
	Private mEventName As String
	Private mBase As Panel
	Private mParkType As String
	Private HeadingPanel As Panel
	Private DetailsPanel As Panel
	Private HeaderLabel As Label
	Private RegoHeaderLabel As Label
	Private RegoLabel As Label
	Private ParkedHeaderLabel As Label
	Private ParkedLabel As Label
	Private ZoneHeaderLabel As Label
	Private ZoneLabel As Label
	Private itemNumber As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(TargetModule As Object, EventName As String)
	mTarget = TargetModule
	mEventName = EventName
End Sub

Public Sub ManualAdd(base As Panel, parkType As String, startLeft As Int, itemNum As Int)
	mBase = base
	itemNumber = itemNum
	HeadingPanel.Initialize("HP")
	HeadingPanel.Color = Colors.Transparent
	DetailsPanel.Initialize("DP")
	DetailsPanel.Color = Colors.Transparent
	HeaderLabel.Initialize("")
	HeaderLabel.TextColor = Colors.White
	RegoHeaderLabel.Initialize("")
	RegoHeaderLabel.TextColor = Colors.White
	RegoLabel.Initialize("")
	RegoLabel.TextColor = Colors.White
	ParkedHeaderLabel.Initialize("")
	ParkedHeaderLabel.TextColor = Colors.White
	ParkedLabel.Initialize("")
	ParkedLabel.TextColor = Colors.White
	ZoneHeaderLabel.Initialize("")
	ZoneHeaderLabel.TextColor = Colors.White
	ZoneLabel.Initialize("")
	ZoneLabel.TextColor = Colors.White	
	mBase.AddView(HeadingPanel,startLeft,0,100%x,mBase.Height/2)
	mBase.AddView(DetailsPanel,startLeft,mBase.Height/2,100%x,mBase.Height/2)
	HeadingPanel.AddView(HeaderLabel,10dip,0,80%x,HeadingPanel.Height/2)
	DetailsPanel.AddView(RegoHeaderLabel,10dip,0,30%x,DetailsPanel.Height/2)
	DetailsPanel.AddView(RegoLabel,10dip,DetailsPanel.Height/2,30%x,DetailsPanel.Height/2)	
	DetailsPanel.AddView(ParkedHeaderLabel,RegoLabel.Width + 10dip,0,45%x,DetailsPanel.Height/2)
	DetailsPanel.AddView(ParkedLabel,RegoLabel.Width + 10dip,DetailsPanel.Height/2,45%x,DetailsPanel.Height/2)		
	DetailsPanel.AddView(ZoneHeaderLabel,ParkedLabel.Left + ParkedLabel.Width + 10dip,0,25%x,DetailsPanel.Height/2)
	DetailsPanel.AddView(ZoneLabel,ZoneHeaderLabel.Left,DetailsPanel.Height/2,25%x,DetailsPanel.Height/2)		
	
	FillDetails(parkType)
End Sub

Public Sub FillDetails(parkType As String)
	mParkType = parkType
	SetupParkView
End Sub

Private Sub SetupParkView
	Select mParkType
		Case PARK_TYPE_NEW
			mBase.Color = NEW_COLOUR
			SetTextSize(HeaderLabel,"New Park")
			SetTextSize(RegoHeaderLabel,"Rego")
		Case PARK_TYPE_CURRENT

			
		Case PARK_TYPE_RECENT
			mBase.Color = RECENT_COLOUR
			SetTextSize(HeaderLabel,"Recent Park " & itemNumber) 
			SetTextSize(RegoHeaderLabel,"Rego")
			SetTextSize(ParkedHeaderLabel,"Parked")
			SetTextSize(ZoneHeaderLabel,"Zone")
	End Select
End Sub

Sub SetTextSize(lbl As Label, txt As String)
	lbl.Text = txt
	Return
   Dim dt As Float
   Dim limit = 0.5 As Float
   Dim h As Int
   Dim stu As StringUtils
   
   lbl.Text = txt
   lbl.TextSize = 72
   dt = lbl.TextSize
   h = stu.MeasureMultilineTextHeight(lbl, txt)   
   Do While dt > limit OR h > lbl.Height
     dt = dt / 2
     h = stu.MeasureMultilineTextHeight(lbl, txt)   
     If h > lbl.Height Then
       lbl.TextSize = lbl.TextSize - dt
     Else
       lbl.TextSize = lbl.TextSize + dt
     End If
   Loop
End Sub